-----------------------------------------------------------------------------------------------
-- Client Lua Script for DungeonStats
-- Copyright (c) NCsoft. All rights reserved
-----------------------------------------------------------------------------------------------
 
require "Window"
 
-----------------------------------------------------------------------------------------------
-- DungeonStats Module Definition
-----------------------------------------------------------------------------------------------
local DungeonStats = {} 
 
-----------------------------------------------------------------------------------------------
-- Constants
-----------------------------------------------------------------------------------------------
-- e.g. local kiExampleVariableMax = 999
 
-----------------------------------------------------------------------------------------------
-- Initialization
-----------------------------------------------------------------------------------------------
DungeonStats.LineObject = nil
function DungeonStats:new(o)
    o = o or {}
    setmetatable(o, self)
    self.__index = self 

    -- initialize variables here

    return o
end

function DungeonStats:Init()
	local bHasConfigureFunction = false
	local strConfigureButtonText = ""
	local tDependencies = {
		-- "UnitOrPackageName",
	}
    Apollo.RegisterAddon(self, bHasConfigureFunction)
end
 

-----------------------------------------------------------------------------------------------
-- DungeonStats OnLoad
-----------------------------------------------------------------------------------------------
function DungeonStats:OnLoad()
	self.config = Apollo.GetPackage("Gemini:DB-1.0").tPackage:New(self)
	
	------- CHAR START ----------------
	--counter char
	if self.config.char.stlCounter == nil then
		self.config.char.stlCounter = 0
	end
	if self.config.char.kvCounter == nil then
		self.config.char.kvCounter = 0
	end
	if self.config.char.scCounter == nil then
		self.config.char.scCounter = 0
	end
	if self.config.char.sotsCounter == nil then
		self.config.char.sotsCounter = 0
	end
	if self.config.char.protoCounter == nil then
		self.config.char.protoCounter = 0
	end
	
	--avgtime char
	if self.config.char.stlAvg == nil then
		self.config.char.stlAvg = 0
	end
	if self.config.char.kvAvg == nil then
		self.config.char.kvAvg = 0
	end
	if self.config.char.scAvg == nil then
		self.config.char.scAvg = 0
	end
	if self.config.char.sotsAvg == nil then
		self.config.char.sotsAvg = 0
	end
	if self.config.char.protoAvg == nil then
		self.config.char.protoAvg = 0
	end
	
	--tot char
	if self.config.char.totkv == nil then
		self.config.char.totkv = 0
	end
	if self.config.char.totstl == nil then
		self.config.char.totstl = 0
	end
	if self.config.char.totsc == nil then
		self.config.char.totsc = 0
	end
	if self.config.char.totsots == nil then
		self.config.char.totsots = 0
	end
	if self.config.char.totproto == nil then
		self.config.char.totproto = 0
	end
	------- CHAR END ----------------
	------- ACC START ----------------
	--fastest acc
	if self.config.global.stlrecord == nil then
		self.config.global.stlrecord = 0
	end
	if self.config.global.kvrecord == nil then
		self.config.global.kvrecord = 0
	end
	if self.config.global.screcord == nil then
		self.config.global.screcord = 0
	end
	if self.config.global.sotsrecord == nil then
		self.config.global.sotsrecord = 0
	end
	if self.config.global.protorecord == nil then
		self.config.global.protorecord = 0
	end
	
	--counter acc
	if self.config.global.stlCounter == nil then
		self.config.global.stlCounter = 0
	end
	if self.config.global.kvCounter == nil then
		self.config.global.kvCounter = 0
	end
	if self.config.global.scCounter == nil then
		self.config.global.scCounter = 0
	end
	if self.config.global.sotsCounter == nil then
		self.config.global.sotsCounter = 0
	end
	if self.config.global.protoCounter == nil then
		self.config.global.protoCounter = 0
	end
	
	--avg acc
	if self.config.global.stlAvg == nil then
		self.config.global.stlAvg = 0
	end
	if self.config.global.kvAvg == nil then
		self.config.global.kvAvg = 0
	end
	if self.config.global.scAvg == nil then
		self.config.global.scAvg = 0
	end
	if self.config.global.sotsAvg == nil then
		self.config.global.sotsAvg = 0
	end
	if self.config.global.protoAvg == nil then
		self.config.global.protoAvg = 0
	end
	
	--tot acc
	if self.config.global.totkv == nil then
		self.config.global.totkv = 0
	end
	if self.config.global.totstl == nil then
		self.config.global.totstl = 0
	end
	if self.config.global.totsc == nil then
		self.config.global.totsc = 0
	end
	if self.config.global.totsots == nil then
		self.config.global.totsots = 0
	end
	if self.config.global.totproto == nil then
		self.config.global.totproto = 0
	end
	
	-------------------- ACC END ----------------
	------------------- Counter Start -------------
	
	if AddCharacterInformationLine ~= nil then
		self.LineObject = AddCharacterInformationLine(
		"DungeonStats",
		"Stormtalon Runs",
		function()
			returnstring = self.config.char.stlCounter .. " [Acc: " .. self.config.global.stlCounter .. "]" 			
			return returnstring
		end,
		nil, 
		nil,
		"The number of Stormtalon Runs you completed.")
	else
		self.LineObject = nil
	end
	
	if AddCharacterInformationLine ~= nil then
		self.LineObject = AddCharacterInformationLine(
		"DungeonStats",
		"Kel Voreth Runs",
		function() 			
			returnstring = self.config.char.kvCounter .. " [Acc: " .. self.config.global.kvCounter .. "]" 			
			return returnstring
		end,
		nil, 
		nil,
		"The number of Kel Voreth Runs you completed.")
	else
		self.LineObject = nil
	end

	if AddCharacterInformationLine ~= nil then
		self.LineObject = AddCharacterInformationLine(
		"DungeonStats",
		"Skullcano Runs",
		function() 			
			returnstring = self.config.char.scCounter .. " [Acc: " .. self.config.global.scCounter .. "]" 			
			return returnstring
		end,
		nil, 
		nil,
		"The number of Skullcano Runs you completed.")
	else
		self.LineObject = nil
	end

	if AddCharacterInformationLine ~= nil then
		self.LineObject = AddCharacterInformationLine(
		"DungeonStats",
		"Swordmaiden Runs",
		function() 			
			returnstring = self.config.char.sotsCounter .. " [Acc: " .. self.config.global.sotsCounter .. "]" 			
			return returnstring
		end,
		nil, 
		nil,
		"The number of SM Runs you completed.")
	else
		self.LineObject = nil
	end
	
	if AddCharacterInformationLine ~= nil then
		self.LineObject = AddCharacterInformationLine(
		"DungeonStats",
		"Protogames Runs",
		function() 			
			returnstring = self.config.char.protoCounter .. " [Acc: " .. self.config.global.protoCounter .. "]" 			
			return returnstring
		end,
		nil, 
		nil,
		"The number of Proto Runs you completed.")
	else
		self.LineObject = nil
	end
	------------------- Counter END -------------
	------------------- AVG START ---------------
	
	if AddCharacterInformationLine ~= nil then
		self.LineObject = AddCharacterInformationLine(
		"DungeonStats",
		"Average Stormtalon Time",
		function() 
			local sec = math.floor(self.config.char.stlAvg % 60)
			if sec < 10 then
				sec = "0" .. math.floor(self.config.char.stlAvg % 60)
			end
			local sec2 = math.floor(self.config.global.stlAvg % 60)
			if sec2 < 10 then
				sec2 = "0" .. math.floor(self.config.global.stlAvg % 60)
			end
			returnstring = math.floor(self.config.char.stlAvg / 60) .. ":" .. sec .. " [Acc: " .. math.floor(self.config.global.stlAvg / 60) .. ":" .. sec2 .. "]" 			
			return returnstring
		end,
		function()
			return "yellow"
		end,  
		nil,
		"The average time for a Stormtalon Run.")
	else
		self.LineObject = nil
	end
	
	if AddCharacterInformationLine ~= nil then
		self.LineObject = AddCharacterInformationLine(
		"DungeonStats",
		"Average Kel Voreth Time",
		function() 	
			local sec = math.floor(self.config.char.kvAvg % 60)
			if sec < 10 then
				sec = "0" .. math.floor(self.config.char.kvAvg % 60)
			end
			local sec2 = math.floor(self.config.global.kvAvg % 60)
			if sec2 < 10 then
				sec2 = "0" .. math.floor(self.config.global.kvAvg % 60)
			end	
			returnstring = math.floor(self.config.char.kvAvg / 60) .. ":" .. sec .. " [Acc: " .. math.floor(self.config.global.kvAvg / 60) .. ":" .. sec2 .. "]" 			
			return returnstring
		end,
		function()
			return "yellow"
		end, 
		nil,
		"The average time for a Kel Voreth Run.")
	else
		self.LineObject = nil
	end
	
	if AddCharacterInformationLine ~= nil then
		self.LineObject = AddCharacterInformationLine(
		"DungeonStats",
		"Average Skullcano Time",
		function()
			local sec = math.floor(self.config.char.scAvg % 60)
			if sec < 10 then
				sec = "0" .. math.floor(self.config.char.scAvg % 60)
			end
			local sec2 = math.floor(self.config.global.scAvg % 60)
			if sec2 < 10 then
				sec2 = "0" .. math.floor(self.config.global.scAvg % 60)
			end
			returnstring = math.floor(self.config.char.scAvg / 60) .. ":" .. sec .. " [Acc: " .. math.floor(self.config.global.scAvg / 60) .. ":" .. sec2 .. "]" 			
			return returnstring
		end,
		function()
			return "yellow"
		end, 
		nil,
		"The average time for a Skullcano Run.")
	else
		self.LineObject = nil
	end
	
	if AddCharacterInformationLine ~= nil then
		self.LineObject = AddCharacterInformationLine(
		"DungeonStats",
		"Average Swordmaiden Time",
		function() 	
			local sec = math.floor(self.config.char.sotsAvg % 60)
			if sec < 10 then
				sec = "0" .. math.floor(self.config.char.sotsAvg % 60)
			end
			local sec2 = math.floor(self.config.global.sotsAvg % 60)
			if sec2 < 10 then
				sec2 = "0" .. math.floor(self.config.global.sotsAvg % 60)
			end	
			returnstring = math.floor(self.config.char.sotsAvg / 60) .. ":" .. sec .. " [Acc: " .. math.floor(self.config.global.sotsAvg / 60) .. ":" .. sec2 .. "]" 			
			return returnstring
		end,
		function()
			return "yellow"
		end, 
		nil,
		"The average time for a SM Run.")
	else
		self.LineObject = nil
	end
	
	if AddCharacterInformationLine ~= nil then
		self.LineObject = AddCharacterInformationLine(
		"DungeonStats",
		"Average Protogames Time",
		function() 	
			local sec = math.floor(self.config.char.protoAvg % 60)
			if sec < 10 then
				sec = "0" .. math.floor(self.config.char.protoAvg % 60)
			end
			local sec2 = math.floor(self.config.global.protoAvg % 60)
			if sec2 < 10 then
				sec2 = "0" .. math.floor(self.config.global.protoAvg % 60)
			end
			returnstring = math.floor(self.config.char.protoAvg / 60) .. ":" .. sec .. " [Acc: " .. math.floor(self.config.global.protoAvg / 60) .. ":" .. sec2 .. "]" 			
			return returnstring
		end,
		function()
			return "yellow"
		end,
		nil,
		"The average time for a Protogame Run.")
	else
		self.LineObject = nil
	end
	------------------- AVG END ---------------
	
	
	------------------- Record STart ---------------
	
	if AddCharacterInformationLine ~= nil then
		self.LineObject = AddCharacterInformationLine(
		"DungeonStats",
		"Fastest Stormtalon Time",
		function() 		
			local sec = math.floor(self.config.global.stlrecord % 60)
			if sec < 10 then
				sec = "0" .. math.floor(self.config.global.stlrecord % 60)
			end
			returnstring = math.floor(self.config.global.stlrecord / 60) .. ":" .. sec
			return returnstring
		end,
		function()
			return "green"
		end, 
		nil,
		"The fastest time for a Stormtalon Run.")
	else
		self.LineObject = nil
	end
	
	if AddCharacterInformationLine ~= nil then
		self.LineObject = AddCharacterInformationLine(
		"DungeonStats",
		"Fastest Kel Voreth Time",
		function() 
			local sec = math.floor(self.config.global.kvrecord % 60)
			if sec < 10 then
				sec = "0" .. math.floor(self.config.global.kvrecord % 60)
			end
			returnstring = math.floor(self.config.global.kvrecord / 60) .. ":" .. sec
			return returnstring
		end,
		function()
			return "green"
		end, 
		nil,
		"The fastest time for a Kel Voreth Run.")
	else
		self.LineObject = nil
	end
	
	if AddCharacterInformationLine ~= nil then
		self.LineObject = AddCharacterInformationLine(
		"DungeonStats",
		"Fastest Skullcano Time",
		function() 	
			local sec = math.floor(self.config.global.screcord % 60)
			if sec < 10 then
				sec = "0" .. math.floor(self.config.global.screcord % 60)
			end
			returnstring = math.floor(self.config.global.screcord / 60) .. ":" .. sec
			return returnstring
		end,
		function()
			return "green"
		end,  
		nil,
		"The fastest time for a Skullcano Run.")
	else
		self.LineObject = nil
	end
	
	if AddCharacterInformationLine ~= nil then
		self.LineObject = AddCharacterInformationLine(
		"DungeonStats",
		"Fastest Swordmaiden Time",
		function() 		
			local sec = math.floor(self.config.global.sotsrecord % 60)
			if sec < 10 then
				sec = "0" .. math.floor(self.config.global.sotsrecord % 60)
			end
			returnstring = math.floor(self.config.global.sotsrecord / 60) .. ":" .. sec
			return returnstring
		end,
		function()
			return "green"
		end,  
		nil,
		"The fastest time for a Swordmaiden Run.")
	else
		self.LineObject = nil
	end
	
	if AddCharacterInformationLine ~= nil then
		self.LineObject = AddCharacterInformationLine(
		"DungeonStats",
		"Fastest Protogames Time",
		function() 			
			local sec = math.floor(self.config.global.protorecord % 60)
			if sec < 10 then
				sec = "0" .. math.floor(self.config.global.protorecord % 60)
			end
			returnstring = math.floor(self.config.global.protorecord / 60) .. ":" .. sec
			return returnstring
		end,
		function()
			return "green"
		end, 
		nil,
		"The fastest time for a Protogames Run.")
	else
		self.LineObject = nil
	end
	
	
	------------------- Record END ---------------
	
	
	
	
    -- load our form file
	self.xmlDoc = XmlDoc.CreateFromFile("DungeonStats.xml")
	self.xmlDoc:RegisterCallback("OnDocLoaded", self)
end

-----------------------------------------------------------------------------------------------
-- DungeonStats OnDocLoaded
-----------------------------------------------------------------------------------------------
function DungeonStats:OnDocLoaded()

	if self.xmlDoc ~= nil and self.xmlDoc:IsLoaded() then
	    self.wndMain = Apollo.LoadForm(self.xmlDoc, "DungeonStatsForm", nil, self)
		if self.wndMain == nil then
			Apollo.AddAddonErrorText(self, "Could not load the main window for some reason.")
			return
		end
		
	    self.wndMain:Show(false, true)

		Apollo.RegisterEventHandler("PublicEventEnd", "updateStats", self)

	end
end

-----------------------------------------------------------------------------------------------
-- DungeonStats Functions
-----------------------------------------------------------------------------------------------
-- Define general functions here
function DungeonStats:round(num, n)
  local mult = 10^(n or 0)
  return math.floor(num * mult + 0.5) / mult
end

function DungeonStats:updateStats(tEvent, eReason, tStats)
	zoneid = GameLib.GetCurrentZoneMap().id --21 = kv 204 = proto
	--Print("event finished, zoneid: " .. zoneid)
	
	if zoneid == 21 then --kv
		Print("kv done")
		if tStats.nElapsedTime ~= nil then
			nTime = tStats.nElapsedTime/1000 -- in sec
			nTime = math.floor(nTime)
		end
		if nTime < 400 then
			return
		end
			
		if self.config.global.kvrecord > nTime or self.config.global.kvrecord == 0 then
			Print("New PB! Old: " .. self.config.global.kvrecord .. " New: " .. nTime)
			self.config.global.kvrecord = nTime
		end
		
		self.config.char.kvCounter = self.config.char.kvCounter + 1
		self.config.global.kvCounter = self.config.global.kvCounter + 1
		
		self.config.global.totkv = self.config.global.totkv + nTime
		self.config.global.kvAvg = (self.config.global.totkv/self.config.global.kvCounter)
		
		self.config.char.totkv = self.config.char.totkv + nTime
		self.config.char.kvAvg = (self.config.char.totkv/self.config.char.kvCounter)
	end
	
	if zoneid == 204 then --proto
		Print("proto done")
		if tStats.nElapsedTime ~= nil then
			nTime = tStats.nElapsedTime/1000 -- in sec
			nTime = math.floor(nTime)
		end
		if nTime < 600 then
			return
		end
		
		
		if self.config.global.protorecord > nTime or self.config.global.protorecord == 0 then
			Print("New PB! Old: " .. self.config.global.protorecord .. "New: " .. nTime)
			self.config.global.protorecord = nTime
		end
		
		self.config.char.protoCounter = self.config.char.protoCounter + 1
		self.config.global.protoCounter = self.config.global.protoCounter + 1
		
		self.config.global.totproto = self.config.global.totproto + nTime
		self.config.global.protoAvg = (self.config.global.totproto/self.config.global.protoCounter)
		
		self.config.char.totproto = self.config.char.totproto + nTime
		self.config.char.protoAvg = (self.config.char.totproto/self.config.char.protoCounter)
	end
	
	if zoneid == 20 then --sc
		Print("sc done")
		if tStats.nElapsedTime ~= nil then
			nTime = tStats.nElapsedTime/1000 -- in sec
			nTime = math.floor(nTime)
		end
		if nTime < 600 then
			return
		end
		
		if self.config.global.screcord > nTime or self.config.global.screcord == 0 then
			Print("New PB! Old: " .. self.config.global.screcord .. "New: " .. nTime)
			self.config.global.screcord = nTime
		end
		--Print(nTime)
		
		self.config.char.scCounter = self.config.char.scCounter + 1
		self.config.global.scCounter = self.config.global.scCounter + 1
		
		self.config.global.totsc = self.config.global.totsc + nTime
		self.config.global.scAvg = (self.config.global.totsc/self.config.global.scCounter)
		
		self.config.char.totsc = self.config.char.totsc + nTime
		self.config.char.scAvg = (self.config.char.totsc/self.config.char.scCounter)
	end
	
	if zoneid == 19 then --stl
		Print("stl done")
		if tStats.nElapsedTime ~= nil then
			nTime = tStats.nElapsedTime/1000 -- in sec
			nTime = math.floor(nTime)
		end
		if nTime < 300 then
			return
		end
		
		if self.config.global.stlrecord > nTime or self.config.global.stlrecord == 0 then
			Print("New PB! Old: " .. self.config.global.stlrecord .. "New: " .. nTime)
			self.config.global.stlrecord = nTime
		end
		
		self.config.char.stlCounter = self.config.char.stlCounter + 1
		self.config.global.stlCounter = self.config.global.stlCounter + 1
		
		self.config.global.totstl = self.config.global.totstl + nTime
		self.config.global.stlAvg = (self.config.global.totstl/self.config.global.stlCounter)
		
		self.config.char.totstl = self.config.char.totstl + nTime
		self.config.char.stlAvg = (self.config.char.totstl/self.config.char.stlCounter)
	end
	
	if zoneid == 85 then --sots
		if tStats.nElapsedTime ~= nil then
			nTime = tStats.nElapsedTime/1000 -- in sec
			nTime = math.floor(nTime)
		end
		if nTime < 1500 then
			return
		end
		
		if self.config.global.sotsrecord > nTime or self.config.global.sotsrecord == 0 then
			Print("New PB! Old: " .. self.config.global.stlrecord .. "New: " .. nTime)
			self.config.global.sotsrecord = nTime
		end
		
		self.config.char.sotsCounter = self.config.char.sotsCounter + 1
		self.config.global.sotsCounter = self.config.global.sotsCounter + 1
		
		self.config.global.totsots = self.config.global.totsots + nTime
		self.config.global.sotsAvg = (self.config.global.totsots/self.config.global.sotsCounter)
		
		self.config.char.totsots = self.config.char.totsots + nTime
		self.config.char.sotsAvg = (self.config.char.totsots/self.config.char.sotsCounter)
	end
	
	
	if self.LineObject == nil then
		Print("<DeathCounter> You need to install the addon 'CharacterInfoPlus' (http://www.curse.com/ws-addons/wildstar/222978-characterinfoplus) to see the new amount into the character window.")
	else
		self.LineObject:forceUpdate()
	end
end



-----------------------------------------------------------------------------------------------
-- DungeonStats Instance
-----------------------------------------------------------------------------------------------
local DungeonStatsInst = DungeonStats:new()
DungeonStatsInst:Init()
